#define SHADER_FLAG_SKINNING_TRS
#define SHADER_FLAG_SKINNING_BONES_PER_VERTEX_2

#include "ff-skinning_vert.inc"

attribute highp   vec4 a_position;
attribute mediump vec2 a_texCoord;
attribute lowp    vec4 a_color;

uniform highp     mat4 u_modelViewProjectionMatrix;

varying mediump   vec2 v_texCoord;
varying lowp      vec4 v_color;

void main() {
	v_texCoord = a_texCoord;
	v_color = a_color * vec4(a_color.a, a_color.a, a_color.a, 1.0);	/* Premultiply alpha */

	gl_Position = u_modelViewProjectionMatrix * CalculateSkinnedPosition(a_position);
	
}
