//varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying lowp vec3 v_normal;
varying lowp mat4 v_viewMatrix;
varying lowp float v_vdn;

uniform sampler2D u_texture;
uniform lowp vec4 RimBleed;
	uniform lowp vec4 LightDirection;
uniform mediump vec4 u_color4;
uniform lowp vec4 u_materialAmbient;
uniform lowp vec4 u_materialDiffuse;
uniform lowp vec4 u_materialSpecular;
uniform lowp vec4 u_materialEmissive;
uniform mediump float u_materialShininess;

void main() {
	vec4 texColor = texture2D(u_texture, v_texCoord);
	float angleDifference = smoothstep(RimBleed.x, 1.0, v_vdn);
	
	float nDotL1 = clamp(dot(vec3(LightDirection.rgb), normalize(v_normal)), 0.0, 1.0);
	
	vec3 light = vec3(u_materialAmbient) +
						vec3(u_materialDiffuse) * nDotL1 +
						vec3(u_materialSpecular) * pow(nDotL1, u_materialShininess);
	
	gl_FragColor = mix(texColor * u_color4 * vec4(light, 1.0), texColor * (u_materialEmissive + 0.1) * 10.0, angleDifference);
}