varying mediump vec3 v_normal;
varying lowp vec2 v_texCoord;
varying mediump vec3 v_camDir;

uniform sampler2D u_texture;
uniform lowp vec4 u_materialAmbient;
uniform lowp vec4 u_materialDiffuse;
uniform lowp vec4 u_materialSpecular;
uniform lowp vec4 u_materialEmissive;
uniform mediump float u_materialShininess;
uniform lowp vec4 u_color4;
uniform lowp vec4 RimLightSettings;

void main() {
	mediump vec3 N = normalize(v_normal);
	mediump vec3 L = vec3(-0.40824828, -0.40824828, 0.81649655);
	mediump vec3 V = normalize(vec3(0.0, 0.0, 1.0));
	
	float NdotL = clamp(dot(N, L), 0.0, 1.0);
	lowp float rim = clamp(1.0 - pow(dot(N, V) * RimLightSettings.x, RimLightSettings.y), 0.0, 1.0);
	
	gl_FragColor = u_color4 * texture2D(u_texture, v_texCoord);	
	
	gl_FragColor.rgb *= vec3(u_materialAmbient) +
						  vec3(u_materialDiffuse) * NdotL +
						  vec3(u_materialSpecular) * pow(NdotL, u_materialShininess);
	gl_FragColor.rgb += u_materialEmissive.rgb * rim;
}