attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
uniform highp mat4 u_modelViewProjectionMatrix;

uniform lowp vec4 u_color4;
uniform lowp vec4 u_materialAmbient;
uniform highp float u_time;
uniform mediump vec4 dist_tiling_scroll1;
uniform mediump vec4 dist_tiling_scroll2;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying lowp vec2 scrollUV1;
varying lowp vec2 scrollUV2;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color * u_color4 * vec4(u_materialAmbient.a, u_materialAmbient.a, u_materialAmbient.a, 1.0);
	v_texCoord = a_texCoord;
	scrollUV1 = v_texCoord.xy*dist_tiling_scroll1.xy+fract(u_time*dist_tiling_scroll1.zw);
	scrollUV2 = v_texCoord.xy*dist_tiling_scroll2.xy+fract(u_time*dist_tiling_scroll2.zw);
}